
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL


#include "ImageDocument.h"
#include "ViewablePage.h"

#include <Foundation/NSString.h>
#include <AppKit/NSImage.h>


/*
 * An ImageDocument represents a Document that consists
 * of one or more Images.
 */
@implementation ImageDocument

/*
 * designated initializer
 */
- (id) init
{
   if (self = [super init])
   {
      // ...?
   }

   return self;
}


- (void) dealloc
{
   NSLog(@"dealloc ImageDocument, retain count is %d", [self retainCount]);
   [super dealloc];
}


/*
 * Implement the NSDocument class. This will create a new document that
 * contains the image stored in the specified file.
 */
- (BOOL) readFromFile: (NSString*)fileName ofType: (NSString*)docType
{
   NSImage*       theImage;
   ViewablePage*  aPage;
   BOOL           succeeded = YES;

   theImage = [[[NSImage alloc] initWithContentsOfFile: fileName] autorelease];
   [theImage setScalesWhenResized: NO];
   if (theImage)
   {
      aPage = [[ViewablePage alloc] initWithImage: theImage];
      [aPage autorelease];
      [self appendPage: aPage];
   }
   else
   {
      NSLog(@"Failed to load Image");
      succeeded = NO;
   }

   return succeeded;
}

@end

