
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_IMAGE_VIEW
#define _H_IMAGE_VIEW

#include <AppKit/NSView.h>

#include "ImageScrollView.h"

// we use forward declarations here because
// Cocoas header files seem to be not include-safe.
@class NSImage;
@class NSTextField;
@class NSString;


@interface ImageView : NSView
{
   ImageScrollView*         scrollView;
   id                       internalImageView;
   NSTextField*             messageView;
   BOOL                     messageDisplayed;
}

- (id) initWithFrame: (NSRect)frameRect;
- (void) dealloc;

- (void) setImage: (NSImage*)anImage;
- (void) updateView;

- (void) sizeToFitImage;
- (void) setImageSize: (NSSize)size;
- (void) displayMessage: (NSString*)message;
- (void) removeMessage;

- (ImageScrollView*) scrollView;

- (void) resizeWithOldSuperviewSize: (NSSize)oldBoundsSize;

@end

#endif
