
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_IMAGE_WINDOW
#define _H_IMAGE_WINDOW

#include <AppKit/NSApplication.h>
#include <AppKit/NSWindow.h>

#include "ImageView.h"


@class ImageWindowController;
@class NSView;
@class NSButton;
@class NSMutableArray;
@class NSProgressIndicator;

@interface ImageWindow : NSWindow
{
   ImageView*             imageView;
   ImageWindowController* myController;
   NSView*                toolbar;
   NSMutableArray*        tbElements;
   NSButton*              tbNextPage;
   NSButton*              tbPrevPage;
   NSButton*              tbZoomIn;
   NSButton*              tbZoomOut;
   NSButton*              tbZoomToRealSize;
   NSButton*              tbSizeToFit;
   NSButton*              tbSizeToFitWidth;
   NSProgressIndicator*   tbProgressBar;
}

- (id) init;
- (void) dealloc;

- (void) setController: (ImageWindowController*)controller;

- (ImageView*) imageView;
- (NSProgressIndicator*) toolbarProgressBar;

- (void) setDisplayPageNavigation: (BOOL)displayPageNav;

@end

#define TOOLBAR_HEIGHT 68.0

#endif
