
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_IMAGE_WINDOW_CONTROLLER
#define _H_IMAGE_WINDOW_CONTROLLER

#include <AppKit/NSWindowController.h>

#include "ViewablePage.h"

@class NSNotification;


#define ZOOM_STEP                   0.1
#define PAGE_ORIENTATION_LANDSCAPE  @"Landscape"
#define PAGE_ORIENTATION_PORTRAIT   @"Portrait"
#define DEFAULT_PAPERSIZE           @"Default"


@interface ImageWindowController : NSWindowController
{
   ViewablePage* currentPage;
   double        scaleFactor;
   BOOL          documentIsDisplayed;
   id            currentPaperSize;
   id            currentPageOrientation;
}

- (id) initWithWindow: (NSWindow*)win;
- (void) dealloc;

- (void) setCurrentPage: (ViewablePage*)aPage;
- (ViewablePage*)currentPage;

- (void) windowDidBecomeMain: (NSNotification*)aNotification;
- (void) windowWillClose: (NSNotification *)aNotification;

- (void) controlTextDidEndEditing: (NSNotification*)aNotification;
- (BOOL) validateMenuItem: (id)menuItem;

- (void) sizePageToMax;
- (void) setScaleFactor: (double)factor;
- (NSSize) scalePageToFitIn: (NSSize)size;
- (double) scaleFactor;

// actions
- (void) firstPage: (id)sender;
- (void) nextPage: (id)sender;
- (void) previousPage: (id)sender;
- (void) lastPage: (id)sender;
- (void) zoomIn: (id)sender;
- (void) zoomOut: (id)sender;
- (void) zoomToRealSize: (id)sender;
- (void) sizePageToFit: (id)sender;
- (void) sizePageToFitWidth: (id)sender;
- (void) setPaperSize: (id)sender;
- (void) setPageOrientation: (id)sender;

@end

#endif
