// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#include "PrefsController.h"
#include "AppController.h"
#include "ViewIt.h"

#include <Foundation/NSDictionary.h>
#include <Foundation/NSUserDefaults.h>
#include <Foundation/NSString.h>
#include <Foundation/NSValue.h>
#include <AppKit/NSTextField.h>


/*
 * Non-Public methods.
 */
@interface PrefsController(Private)
@end


/*
 * Controller for the ViewIt preferences.
 */
@implementation PrefsController

- (id) init
{
   if (self = [super init])
   {
      // ...
   }
   
   return self;
}



- (void) dealloc
{
   [super dealloc];
}


- (void) awakeFromNib
{
   NSUserDefaults* defs = [NSUserDefaults standardUserDefaults];

   [[AppController sharedController] setPrefsController: self];

   // init preferences values
   [gsExecutable setStringValue: [defs objectForKey: PREFS_GS_EXECUTABLE]];
   [cacheSize setIntValue: [[defs objectForKey: PREFS_CACHE_SIZE] intValue]];
   [prefetchCount setIntValue: [[defs objectForKey: PREFS_PREFETCH_COUNT] intValue]];
}


- (id) window
{
   return window;
}


- (void) windowWillClose: (NSNotification*)aNotification
{
   NSUserDefaults* defs = [NSUserDefaults standardUserDefaults];

   // save preferences
   [defs setObject: [gsExecutable stringValue] forKey: PREFS_GS_EXECUTABLE];
   [defs setObject: [NSNumber numberWithInt: [cacheSize intValue]]
         forKey: PREFS_CACHE_SIZE];
   [defs setObject: [NSNumber numberWithInt: [prefetchCount intValue]]
         forKey: PREFS_PREFETCH_COUNT];
}



@end
