

// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_VIEWABLE_DOCUMENT
#define _H_VIEWABLE_DOCUMENT

#include <Foundation/NSGeometry.h>
#include <AppKit/NSDocument.h>

@class NSMutableArray;
@class NSLock;
@class NSObject;
@class ViewablePage;

typedef enum PageOrientation
{
   PageOrientation_Portrait,
   PageOrientation_Landscape
} PageOrientation;

@interface ViewableDocument : NSDocument
{
   NSMutableArray* pageStore;
   NSLock*         pageStoreLock;          
}

- (id) init;
- (void) dealloc;

- (unsigned int) countPages;
- (ViewablePage*) pageAt: (unsigned int)index;
- (void) appendPage: (ViewablePage*)aPage;

- (BOOL) canSetPapersize;
- (void) setPapersize: (NSSize)paperSize;
- (void) setPageOrientation: (PageOrientation)orientation;

- (void) documentIsDisplayed;

// NSDocument stuff
- (void) close;
- (void) makeWindowControllers;

// Subclasses have to implement the type-specific methods of
// NSDocument (like loadDataRepresentation:ofType:). See there 
// for detailed informations.

@end

#endif
