
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_VIEWABLE_PDF_DOCUMENT
#define _H_VIEWABLE_PDF_DOCUMENT

#include "ViewableDocument.h"

@class NSString;
@class PDFDocument;
@class PageCache;


@interface ViewablePDFDocument : ViewableDocument
{
   PDFDocument*  pdfDoc;
   id            renderer;
   PageCache*    cache;
}

- (id) init;
- (void) dealloc;

- (BOOL) readFromFile: (NSString*)fileName ofType: (NSString*)docType;

- (PageCache*) cache;
- (id) renderer;
- (id) pdfDoc;
- (void) setScaleFactor: (double)factor;

- (BOOL) canSetPapersize;
- (void) setPapersize: (NSSize)papersize;
- (void) setPageOrientation: (PageOrientation)orientation;

- (void) documentIsDisplayed;

@end

#endif
