
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_VIEWABLE_PAGE
#define _H_VIEWABLE_PAGE

#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>

@class NSImage;
@class ViewableDocument;


@interface ViewablePage : NSObject
{   
   int               pageNum;
   NSImage*          myImage;
   NSSize            imageBaseSize;
}

- (id) init;
- (id) initWithImage: (NSImage*)anImage;
- (id) initWithImage: (NSImage*)anImage pageNumber: (int)pageNumber;
- (void) dealloc;

- (void) setPageNumber: (int)num;
- (int) pageNumber;

- (NSImage*) image;
- (NSImage*) imageScaledBy: (double)factor;
- (BOOL) canScale;

- (void) updateImage: (NSImage*)newImage;

- (BOOL) providesMinipage;
- (NSImage*) minipage;

@end

#endif
