// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL


#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

#include "ViewIt.h"
#include "AppController.h"


/*
 * Function protoypes. Wy is this still necessary?
 */
void createMenu();


/*
 * Basic-Initialization and Application startup.
 */
int main(int argc, const char *argv[])
{
   id NSApp;

   NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

   [AppController sharedController];

   NSApp = [NSApplication sharedApplication];

   createMenu();

   [NSApp setDelegate: [AppController sharedController]];
   
   [NSApp run];

   [[AppController sharedController] release];
   [NSApp release];
   [pool release];

   return EXIT_SUCCESS;
}


/*
 * Create the Applications Menu.
 */
void createMenu()
{
   // The OSX Variant uses a nib file.
#ifndef MACOSX
   NSMenu* menu;
   NSMenu* info;
   NSMenu* document;
   NSMenu* papersize;
   NSMenu* windows;
   NSMenu* services;

   SEL action = @selector(method:);

   // Application Menu
   menu = [[NSMenu alloc] initWithTitle: APP_NAME];

   [menu addItemWithTitle: @"Info" action: action keyEquivalent: @""];
   [menu addItemWithTitle: @"Document" action: action keyEquivalent: @""];
   [menu addItemWithTitle: @"Papersize" action: action keyEquivalent: @""];
   [menu addItemWithTitle: @"Windows" action:action keyEquivalent:@""];
   [menu addItemWithTitle: @"Services" action: action keyEquivalent:@""];
   [menu addItemWithTitle: @"Hide" action: @selector(hide:) keyEquivalent: @"h"];
   [menu addItemWithTitle: @"Quit" action: @selector(terminate:) keyEquivalent: @"q"];

   // Info Menu
   info = [[[NSMenu alloc] init] autorelease];
   [menu setSubmenu: info forItem: [menu itemWithTitle: @"Info"]];

   [info addItemWithTitle:_(@"Info Panel...") action: @selector(showInfoPanel:)
        keyEquivalent:@""];
   [[info itemWithTitle: @"Info Panel..."] setTarget: [AppController sharedController]];

   [info addItemWithTitle: @"Preferences" action: @selector(showPrefs:)
         keyEquivalent: @""];
   [[info itemWithTitle: @"Preferences"] setTarget: [AppController sharedController]];

   // Document Menu
   document = [[[NSMenu alloc] init] autorelease];
   [menu setSubmenu: document forItem: [menu itemWithTitle: @"Document"]];
   
   [document addItemWithTitle: @"Open... " action: @selector(openDocument:)
             keyEquivalent: @"o"];

   // Papersize Menu
   papersize = [[[NSMenu alloc] init] autorelease];
   [menu setSubmenu: papersize forItem: [menu itemWithTitle: @"Papersize"]];

   [papersize addItemWithTitle: @"Portrait" action: @selector(setPageOrientation:)
              keyEquivalent: @""];
   [papersize addItemWithTitle: @"Landscape" action: @selector(setPageOrientation:)
              keyEquivalent: @""];
   [papersize addItem: [NSMenuItem separatorItem]];

   // Windows Menu
   windows = [[[NSMenu alloc] init] autorelease];
   [menu setSubmenu: windows forItem: [menu itemWithTitle: @"Windows"]];

   [windows addItemWithTitle: @"Arrange"  action:@selector(arrangeInFront:)
            keyEquivalent:@""];
   [windows addItemWithTitle: @"Miniaturize" action:@selector(performMiniaturize:)
            keyEquivalent:@"m"];
   [windows addItemWithTitle: @"Close" action:@selector(performClose:)
            keyEquivalent:@"w"];

   // Services Menu
   services = [[[NSMenu alloc] init] autorelease];
   [menu setSubmenu: services forItem: [menu itemWithTitle: @"Services"]];


   [[NSApplication sharedApplication] setMainMenu: menu];
   [[NSApplication sharedApplication] setServicesMenu: services];
   [[NSApplication sharedApplication] setWindowsMenu: windows];
#else
   if (![NSBundle loadNibNamed: MAIN_MENU_NIB owner: [NSApplication sharedApplication]])
   {
      NSLog(@"Load of %@ nib failed.", MAIN_MENU_NIB);
   }
#endif
}
