
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_CACHE_LOADER
#define _H_CACHE_LOADER

#ifdef MACOSX
#import <Foundation/NSObject.h>
#else
#include <Foundation/NSObject.h>
#endif

@class NSConditionLock;
@class NSLock;
@class PageCache;

@interface CacheLoader : NSObject
{
   PageCache*            cache;
   NSConditionLock*      syncLock;
   NSLock*               startLock;
   BOOL                  continueUpdate;
   BOOL                  interruptCaching;
   BOOL                  isRunning;
   int                   cacheBasePage;
}


- (id) initWithCache: (PageCache*)theCache;
- (void) dealloc;

- (void) run: (id)threadParam;
- (BOOL) isRunning;
- (int) cacheBasePage;

- (void) interruptCachingAsSoonAsPossible;

- (void) start;
- (void) continueWithBasePage: (int)basePage;
- (void) terminate;


@end

#endif
