
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_PDF_DOCUMENT
#define _H_PDF_DOCUMENT

#ifdef MACOSX
#import <Foundation/NSObject.h>
#else
#include <Foundation/NSObject.h>
#endif

// we use forward declarations here because
// Cocoas header files seem to be not include-safe.
@class NSString;


@interface PDFDocument : NSObject
{
   void* pdfDoc;
}

- (id) init;
- (void) dealloc;

// Create a new PDF Document from an input file. 
// If the document could not be created, an invalid
// Document is returned (isOk returns NO). Use errorCode
// to get the reason of the failure.
// All returned objects are autoreleased.
+ (PDFDocument*)documentFromFile: (NSString*)fileName;

+ (PDFDocument*)documentFromFile: (NSString*)fileName 
                   ownerPassword: (NSString*)ownerPassword
                    userPassword: (NSString*)userPassword;

- (BOOL) isOk;
- (int) errorCode;

- (double) pageWidth: (int)pageNum;
- (double) pageHeight: (int)pageNum;
- (int) pageRotate: (int)pageNum;

- (int) numPages;

- (NSString*)metaData; 
// returns nil if no MetaData is available
// otherwise an autoreleases string object.

@end

// only for internal usage
@interface PDFDocument(Wrapper)
- (void*) xpdfobject;
@end

#endif
