
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#include "PDFImageRep.h"

#include <Foundation/NSString.h>
#include <Foundation/NSException.h>
#include <Foundation/NSArray.h>
#include <Foundation/NSData.h>
#include <AppKit/NSPasteboard.h>
#include <AppKit/NSBezierPath.h>
#include <AppKit/NSColor.h>
#include <AppKit/NSGraphicsContext.h>
#include <AppKit/NSFont.h>
#ifdef MACOSX
#import <ApplicationServices/ApplicationServices.h>
#else
#include <AppKit/DPSOperators.h>
#endif

#include <stdlib.h>

/*
 * Non-Public methods.
 */
@interface PDFImageRep(Private)
@end


void _glyphsForChars(char *chars, NSGlyph* glyphs, size_t length)
{
   NSString*      unicodeString;
   unichar        unicharBuf[length];
   NSGlyph        ch;
   int            i;
   NSGlyph*       currentGlyph;

   // convert characters to unicode
   unicodeString = [[NSString alloc] initWithCStringNoCopy: chars 
                                     length: length
                                     freeWhenDone: NO];

   printf("DEBUG 1: >%s<\n", [unicodeString cString]);

   [unicodeString getCharacters: unicharBuf
                  range: NSMakeRange(0, length)];
   [unicodeString release];

   // create glyps
   glyphs = (NSGlyph*)malloc(sizeof(NSGlyph) * length);
   memset(glyphs, 0, sizeof(NSGlyph) * length);

   printf("DEBUG 2: >%s<\n", chars);
   printf("DEBUG 3: >%s<\n", [[NSString stringWithCharacters: unicharBuf length: length] cString]);

   currentGlyph = glyphs;
   for (i = 0; i < length; i++)
   {
      ch = unicharBuf[i];
      // .... (see GSLayoutManager)
      glyphs[i] = ch;
      printf("%ld|%ld ", ch, glyphs[i]);
   }
}


/*
 * describe class 
 */
@implementation PDFImageRep

+ (void) initialize
{
   [super initialize];
}

- (id) init
{
   if (self = [super init])
   {
      // ....
   }

   return self;
}


- (void) dealloc
{
   NSLog(@"dealloc PDFImageRep, retain count is %d", [self retainCount]);
   
   [super dealloc];
}

+ (BOOL) canInitWithData: (NSData*)data
{
   return NO;
}


+ (BOOL) canInitWithPasteboard: (NSPasteboard*)pasteboard
{
   return NO;
}


+ (NSArray*) imageFileTypes
{
   return [self imageUnfilteredFileTypes];
}


+ (NSArray*) imageUnfilteredFileTypes
{
   return [NSArray array];
}


+ (NSArray*) imagePasteboardTypes
{
   return [self imageUnfilteredPasteboardTypes];
}


+ (NSArray*) imageUnfilteredPasteboardTypes
{
   return [NSArray array];
}


- (BOOL) drawInRect: (NSRect)rect
{
   float f;
   int   lc = 0;

   NSGraphicsContext* gc = GSCurrentContext();

   NSLog(@"draw pdf image");

   [[NSColor whiteColor] set];
   DPSrectfill(gc, rect.origin.x, rect.origin.y, rect.size.width, rect.size.height);

   for (f = rect.origin.x; f < rect.origin.x + rect.size.width; f = f + 4)
   {
      [[NSColor blueColor] set];
      DPSnewpath(gc);
      DPSsetlinewidth(gc, 1.0);
      DPSmoveto(gc, f, rect.origin.y);
      DPSlineto(gc, f, rect.origin.y + rect.size.height);
      DPSstroke(gc);
      lc++;
   }

   for (f = rect.origin.y; f < rect.origin.y + rect.size.height; f = f + 4)
   {
      [[NSColor greenColor] set];
      DPSnewpath(gc);
      DPSsetlinewidth(gc, 1.0);
      DPSmoveto(gc, rect.origin.x, f);
      DPSlineto(gc, rect.origin.x + rect.size.width, f);
      DPSstroke(gc);
      lc++;
   }

   NSLog(@"number of lines drawn: %d", lc);

   /*
   DPSnewpath(gc);

   [[NSColor whiteColor] set];
   DPSrectfill(gc, rect.origin.x, rect.origin.y, rect.size.width, rect.size.height);

   [[NSColor blueColor] set];
   DPSsetlinewidth(gc, 10);
   DPSgsave(gc);

   [[NSColor redColor] set];
   DPSsetlinewidth(gc, 5);
   DPSmoveto(gc, rect.origin.x + 5, rect.size.height/2);
   DPSlineto(gc, rect.origin.x + rect.size.width - 5, rect.size.height/2);
   DPSstroke(gc);

   [[NSColor blackColor] set];
   DPSsetlinewidth(gc, 2.5);
   DPSgrestore(gc);
   DPSmoveto(gc, rect.origin.x + rect.size.width/2, rect.origin.y + 5);
   DPSlineto(gc, rect.origin.x + rect.size.width/2, rect.origin.y + rect.size.height - 5);
   DPSstroke(gc);
   */

   return YES;
}

@end
