
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_PDF_RENDERER
#define _H_PDF_RENDERER

#ifdef MACOSX
#import <Foundation/NSObject.h>
#import <Foundation/NSGeometry.h>
#else
#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>
#endif

@class NSImage;
@class NSArray;
@class PDFDocument;
@class Ghostscript;
@class NSString;

typedef enum PDFRPageOrientation
{
   PDFROrientation_Landscape,
   PDFROrientation_Portrait
} PDFRPageOrientation;


@interface PDFRenderer : NSObject
{
   PDFDocument*  myDocument;
   Ghostscript*  gs;
   id            gsOutputHandler;

   int                  baseXRes;
   int                  baseYRes;
   float                scale;
   NSSize               paperSize;
   PDFRPageOrientation  pageOrientation;
}

- (id) initWithDocument: (PDFDocument*)pdfDoc 
                   xRes: (int)xResolution
                   yRes: (int)yResolution
           gsExecutable: (NSString*)gsExecutable
        gsOutputHandler: (id)handler;

- (id) initWithDocument: (PDFDocument*)pdfDoc 
                   xRes: (int)xResolution
                   yRes: (int)yResolution
           gsExecutable: (NSString*)gsExecutable;
   
- (void) dealloc;

- (NSArray*) renderFirstPage: (int)firstPage
                    lastPage: (int)lastPage;
- (NSImage*) renderPage: (int)page;
- (NSArray*) render;

- (void) setGsOutputHandler: (id)handler;

- (BOOL) setScale: (float)newScale;
- (float) scale;
- (BOOL) setPaperSize: (NSSize)size;
- (NSSize) paperSize;
- (BOOL) setPageOrientation: (PDFRPageOrientation)orientation;
- (PDFRPageOrientation) pageOrientation;
- (PDFDocument*) document;

@end

#endif
