
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL

#ifndef _H_PDF_RENDERER2
#define _H_PDF_RENDERER2

#ifdef MACOSX
#import <Foundation/NSObject.h>
#import <Foundation/NSGeometry.h>
#else
#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>
#endif

@class NSImage;
@class NSArray;
@class PDFDocument;
@class Ghostscript;


@interface PDFRenderer2 : NSObject
{
   PDFDocument*  myDocument;

   int           baseXRes;
   int           baseYRes;
   float         scale;
   NSSize        paperSize;
}

- (id) initWithDocument: (PDFDocument*)pdfDoc 
                   xRes: (int)xResolution
                   yRes: (int)yResolution;
- (void) dealloc;

- (NSArray*) renderFirstPage: (int)firstPage
                    lastPage: (int)lastPage;
- (NSImage*) renderPage: (int)page;
- (NSArray*) render;

- (BOOL) setScale: (float)newScale;
- (float) scale;
- (BOOL) setPaperSize: (NSSize)size;
- (NSSize) paperSize;
- (PDFDocument*) document;

@end

#endif
