
// created 06.2003 by Stefan Kleine Stegemann
// 
// licensed under GPL


#include "PDFDocument.h"
#include "PDFRenderer.h"
#include "Ghostscript.h"
#include "PageCache.h"

#include <stdio.h>
#include <Foundation/NSString.h>
#include <Foundation/NSAutoreleasePool.h>

/*
 * Just for testing purposes.
 */
int main(int argc, const char *argv[])
{
   int foo;

   if (argc != 2)
   {
      printf("Invoke with filename as first argument.\n");
   }
   else
   {
      NSString* filename;
      NSAutoreleasePool* apool;
      PDFDocument* pdfDoc;
      PDFRenderer* renderer;
      PageCache*   cache;

      apool = [[NSAutoreleasePool alloc] init];
      
      filename = [[[NSString alloc] initWithCString: argv[1]] autorelease];
      pdfDoc = [PDFDocument documentFromFile: filename];

      if ([pdfDoc isOk])
      {
         printf("Number of Pages: %d\n", [pdfDoc numPages]);
         //printf("Meta-Data:\n<%s>\n", [[pdfDoc metaData] cString]);
         
         renderer = [[[PDFRenderer alloc] initWithDocument: pdfDoc
                                          xRes: 72 yRes: 72] autorelease];

         cache = [[[PageCache alloc] initWithRenderer: renderer
                                     cacheSize: 4
                                     prefetchCount: 1] autorelease];

         [renderer setScale: 2.0];

         [cache imageForPage: 5];

         printf("rendering completed\n");
      }
      else
      {
         printf("Error %d opening pdf file %s.\n", [pdfDoc errorCode], argv[1]);
      }

      [apool release];
   }

   return 0;
}
